#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct BigQueryLocator {
    #[serde(rename = "valueColumn")]
    value_column: super::ColumnName,
    #[serde(rename = "timeColumn")]
    time_column: super::ColumnName,
    #[builder(default, map(key(type = String, into), value(type = String, into)))]
    #[serde(
        rename = "tagValues",
        skip_serializing_if = "std::collections::BTreeMap::is_empty",
        default
    )]
    tag_values: std::collections::BTreeMap<String, String>,
    #[serde(rename = "type")]
    type_: super::BigQueryType,
}
impl BigQueryLocator {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        value_column: super::ColumnName,
        time_column: super::ColumnName,
        type_: super::BigQueryType,
    ) -> Self {
        Self::builder()
            .value_column(value_column)
            .time_column(time_column)
            .type_(type_)
            .build()
    }
    /// The name of the column which has the values for this series
    #[inline]
    pub fn value_column(&self) -> &super::ColumnName {
        &self.value_column
    }
    /// The name of the column which has the timestamps for this series
    #[inline]
    pub fn time_column(&self) -> &super::ColumnName {
        &self.time_column
    }
    /// The mapping of columns to column values to filter on
    #[inline]
    pub fn tag_values(&self) -> &std::collections::BTreeMap<String, String> {
        &self.tag_values
    }
    #[inline]
    pub fn type_(&self) -> &super::BigQueryType {
        &self.type_
    }
}
